#include "checksum.h"

#include <iostream>

CheckSum::CheckSum(void) {
  g=0x0000000104C11DB7LL;
  start();
};

void CheckSum::start(void) {
  r=0;
  count=0;
};

void CheckSum::add(void* buf,unsigned long long int len) { 
  for(unsigned long long int i=0;i<len;i++) {
    unsigned char c = ((unsigned char *)buf)[i];
    for(int n=0;n<8;n++) {
      r<<=1; if(c & 0x80) r|=1; c<<=1;
      if(r & 0x0000000100000000LL) r^=g;
    };
  };
  count+=len;
};

uint32_t CheckSum::end(void) {
  unsigned long long count_ = count;
  uint64_t r_ = r;
  unsigned long long l = count;
  for(;l;) {
    unsigned char c = (l & 0xFF);
    add(&c,1);
    l>>=8;
  };
  uint32_t u = 0;
  add(&u,4);
  uint64_t res=((~r) & 0xFFFFFFFF);
  count=count_;
  r=r_;
  return res;
};

